<?php
/*
Simple:Press
Post Rating Plugin Support Routines
$LastChangedDate: 2013-02-17 13:17:53 -0700 (Sun, 17 Feb 2013) $
$Rev: 9857 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_rating_uninstall_option_links($actionlink, $plugin) {
	if ($plugin == 'post-rating/sp-rating-plugin.php') {
        $url = SFADMINPLUGINS.'&amp;action=uninstall&amp;plugin='.$plugin.'&amp;sfnonce='.wp_create_nonce('forum-adminform_plugins');
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Uninstall this plugin', 'sp-rating')."'>".__('Uninstall', 'sp-rating').'</a>';
        $url = SFADMINOPTION.'&amp;tab=display';
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Options', 'sp-rating')."'>".__('Options', 'sp-rating').'</a>';
    }
	return $actionlink;
}

function sp_rating_do_load_js($footer) {
    $script = (defined('SP_SCRIPTS_DEBUG') && SP_SCRIPTS_DEBUG) ? PRSCRIPT.'sp-rating-dev.js' : PRSCRIPT.'sp-rating.js';
	sp_plugin_enqueue_script('spratings', $script, array('jquery'), false, $footer);
}

function sp_rating_do_header() {
	$css = sp_find_css(PRCSS, 'sp-rating.css');
    sp_plugin_enqueue_style('sp-rating', $css);
}

function sp_rating_do_create_forum() {
	?>
	<tr>
	<td class="sflabel" colspan="2"><label for="sfforum_ratings"><?php _e('Enable post rating on this forum', 'sp-rating') ?></label></td>
	<td><input type="checkbox" checked="checked" id="sfforum_ratings" name="forum_ratings" /></td>
	</tr>
	<?php
}

function sp_rating_do_edit_forum($forum) {
	?>
	<tr>
		<td class="sflabel"><label for="sfforum_ratings_<?php echo $forum->forum_id; ?>"><?php _e('Enable post ratings on this forum', 'sp-rating') ?></label>
		<input type="checkbox" id="sfforum_ratings_<?php echo $forum->forum_id; ?>" name="forum_ratings"
		<?php if ($forum->post_ratings == TRUE) {?> checked="checked" <?php } ?> />
		</td>
	</tr>
	<?php
}

function sp_rating_do_deactivate() {
    # deactivation so make our auth not active
    sp_deactivate_auth('rate_posts');
}

function sp_rating_do_topic_delete($posts) {
	# remove any post ratings in this topic
	$thisTopic = (is_object($posts)) ? $posts : $posts[0];
	$rated = spdb_select('set', 'SELECT '.SPRATINGS.'.post_id, members FROM '.SPRATINGS.'
			 JOIN '.SFPOSTS.' ON '.SPRATINGS.'.post_id = '.SFPOSTS.'.post_id
			 WHERE '.SFPOSTS.".topic_id=$thisTopic->topic_id");
	if ($rated) {
		foreach ($rated as $post) {
			# remove the post rating
			spdb_query('DELETE FROM '.SPRATINGS." WHERE post_id=$post->post_id");

			# remove the posts rated data from sfmembers table
			$members = unserialize($post->members);
			if ($members) {
				# loop through each members that rated a post in this topic and remove the rating
				foreach ($members as $member) {
					$ratedposts = spdb_table(SFMEMBERS, "user_id=$member", 'posts_rated');
					if ($ratedposts) {
						# save any other rated posts only removing posts from this topic
						$new_ratings = '';
						$ratedposts = unserialize($ratedposts);
						foreach ($ratedposts as $ratedpost) {
							if ($ratedpost != $post->post_id) $new_ratings[] = $ratedpost;
						}
						if ($new_ratings == '') {
							spdb_query('UPDATE '.SFMEMBERS." SET posts_rated=NULL WHERE user_id=$member");
						} else {
							$new_ratings = serialize($new_ratings);
							spdb_query('UPDATE '.SFMEMBERS." SET posts_rated='$new_ratings' WHERE user_id=.$member");
						}
					}
				}
			}
		}
	}
}

function sp_rating_do_post_delete($post) {
	# remove post ratings
	$rated = spdb_table(SPRATINGS, "post_id=$post->post_id", 'members');
	if ($rated) {
		$members = unserialize($rated);
		if ($members) {
			# loop through each members that rated a post in this topic and remove the rating
			foreach ($members as $member) {
				$ratedposts = spdb_table(SFMEMBERS, "user_id=$member", 'posts_rated');
				if ($ratedposts) {
					# save any other rated posts only removing posts from this topic
					$new_ratings = '';
					$ratedposts = unserialize($ratedposts);
					foreach ($ratedposts as $ratedpost) {
						if ($ratedpost != $postid) $new_ratings[] = $ratedpost;
					}
					if ($new_ratings == '') {
						spdb_query('UPDATE '.SFMEMBERS.' SET posts_rated=NULL WHERE user_id='.$member);
					} else {
						$new_ratings = serialize($new_ratings);
						spdb_query('UPDATE '.SFMEMBERS." SET posts_rated='$new_ratings' WHERE user_id=.$member");
					}
				}
			}
		}
	}
	spdb_query('DELETE FROM '.SPRATINGS." WHERE post_id=$post->post_id");
}

function sp_rating_do_member_del($userid) {
 	$ratings = spdb_table(SFMEMBERS, "user_id=$userid", 'posts_rated');
	$ratings = unserialize($ratings);
	if (!empty($ratings)) {
		foreach ($ratings as $postid) {
			sp_remove_postrated($postid, $userid);
		}
	}
}

?>