<?php
/*
Simple:Press
Post Rating plugin install/upgrade routine
$LastChangedDate: 2013-02-17 13:17:53 -0700 (Sun, 17 Feb 2013) $
$Rev: 9857 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_rating_do_install() {
	$oldrating = sp_get_option('sfpostratings');
	$ratingdata = sp_get_option('postratings');
	if (empty($oldrating) && empty($ratingdata)) {
        # brand new install
		$sql = '
			CREATE TABLE IF NOT EXISTS '.SPRATINGS.' (
				rating_id bigint(20) NOT NULL auto_increment,
				post_id bigint(20) NOT NULL,
				vote_count bigint(20) NOT NULL,
				ratings_sum bigint(20) NOT NULL,
				ips longtext,
				members longtext,
				PRIMARY KEY  (rating_id)
			) ENGINE=MyISAM '.spdb_charset();
		spdb_query($sql);

        # need new columns
        spdb_query('ALTER TABLE '.SFFORUMS.' ADD (post_ratings smallint(1) NOT NULL default 0)');
        spdb_query('ALTER TABLE '.SFMEMBERS.' ADD (posts_rated longtext)');

		$ratingdata = array();
        $ratingdata['ratingsstyle'] = 1;
		$ratingdata['dbversion'] = SPRATINGDBVERSION;
		sp_add_option('postratings', $ratingdata);
    } elseif (empty($ratingdata)) {
        # upgrade from when it was part of core
   		$new_rating = array();
		$new_rating['ratingsstyle'] = $oldrating['ratingsstyle'];

		$sfdisplay = sp_get_option('sfdisplay');
		if (!empty($sfdisplay['topics']['postrating'])) {
			unset($sfdisplay['topics']['postrating']);
			sp_update_option('sfdisplay', $sfdisplay);
		}

		$new_rating['dbversion'] = SPRATINGDBVERSION;
		sp_add_option('postratings', $new_rating);
		sp_delete_option('sfpostratings');
    }

    # add our tables to installed list
   	$tables = sp_get_option('installed_tables');
    if ($tables && !in_array(SPRATINGS, $tables)) {
        $tables[] = SPRATINGS;
        sp_update_option('installed_tables', $tables);
    }

    # add a new permission into the auths table
	sp_add_auth('rate_posts', __('Can rate a post', 'sp-rating'), 1, 1, 0, 0, 1);

    # activation so make our auth active
    sp_activate_auth('rate_posts');
}

function sp_rating_do_permissions_reset() {
	sp_add_auth('rate_posts', __('Can rate a post', 'sp-rating'), 1, 1, 0, 0, 1);
}
?>