<?php
/*
$LastChangedDate: 2013-02-17 13:17:53 -0700 (Sun, 17 Feb 2013) $
$Rev: 9857 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_PostIndexRatePostTag($args='') {
	global $spThisTopic, $spThisPost, $spThisUser;

	# bail if post rating not enabled for current forum
	if (!$spThisTopic->post_ratings) return;

	$defs = array('tagId' 		=> 'spPostIndexPostRating%ID%',
				  'tagClass' 	=> 'spPostRating',
				  );
	$a = wp_parse_args($args, $defs);
	$a = apply_filters('sph_PostIndexRatePost_args', $a);
	extract($a, EXTR_SKIP);

	# sanitize before use
	$tagId			= esc_attr($tagId);
	$tagClass		= esc_attr($tagClass);

	$tagId = str_ireplace('%ID%', $spThisPost->post_id, $tagId);

	$out = '';
	$postid = $spThisPost->post_id;
	$postratings = sp_get_option('postratings');
	$out.= "<div id='$tagId' class='$tagClass'>";
	if (!isset($spThisPost->rating_id)) {
		$ratings = 0;
		$votes = 0;
		$voted = false;
	} else {
		$ratings = $spThisPost->ratings_sum;
		$votes = $spThisPost->vote_count;
		if ($spThisUser->member) {
			$members = unserialize($spThisPost->members);
			if ($members) {
				$voted = array_search($spThisUser->ID, $members);
			} else {
				$voted = -1;
			}
		} else {
			$ips = unserialize($spThisPost->ips);
			if ($ips) {
				$voted = array_search(sp_get_ip(), $ips);
			} else {
				$voted = -1;
			}
		}
	}

	if ($postratings['ratingsstyle'] == 1) { # thuumb rating
		$out.= '<div class="spPostRatingContainer spPostRatingThumbs">';
        $site = SFHOMEURL.'index.php?sp_ahah=rating-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;fid='.$spThisTopic->forum_id."&amp;pid=$postid&amp;rate=down";
		$downlink = 'style="cursor: pointer;" onclick="javascript:spRatingRatePost(\''.$postid.'\', \''.$site.'\', 1);" ';
        $site = SFHOMEURL.'index.php?sp_ahah=rating-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;fid='.$spThisTopic->forum_id."&amp;pid=$postid&amp;rate=up";
		$uplink = 'style="cursor: pointer;" onclick="javascript:spRatingRatePost(\''.$postid.'\', \''.$site.'\', 1);" ';
		$downimg = sp_find_icon(PRIMAGES, 'sp_RateDown.png');
		$upimg = sp_find_icon(PRIMAGES, 'sp_RateUp.png');
		$uptext = __('Rate this post up', 'sp-rating');
		$downtext = __('Rate this post down', 'sp-rating');
		if (is_numeric($voted) || !sp_get_auth('rate_posts', $spThisTopic->forum_id) || $spThisPost->user_id == $spThisUser->ID) {
			$downlink = '';
			$uplink = '';
			$downimg = sp_find_icon(PRIMAGES, 'sp_RateDownGrey.png');
			$upimg = sp_find_icon(PRIMAGES, 'sp_RateUpGrey.png');
			$uptext = __('Current post rating', 'sp-rating').': '.$ratings;
			$downtext = $uptext;
		}

        if ($ratings > 0) $ratings = '+'.$ratings;
		$out.= "<span class='spPostRatingScore'>$ratings</span>";
		$out.= "<span class='spPostRateDown'><img class='spIcon vtip' src='$downimg' alt='' title='".esc_attr($downtext)."' $downlink /></span>";
		$out.= "<span class='spPostRateUp'><img class='spIcon vtip' src='$upimg' alt='' title='".esc_attr($uptext)."' $uplink /></span>";
	} else {
		$out.= '<div class="spPostRatingContainer spPostRatingStars">';
		$offimg = sp_find_icon(PRIMAGES, 'sp_RateStarOff.png');
		$onimg = sp_find_icon(PRIMAGES, 'sp_RateStarOn.png');
		$overimg = sp_find_icon(PRIMAGES, 'sp_RateStarOver.png');
		if ($votes) {
			$star_rating = round($ratings / $votes, 1);
		} else {
			$star_rating = 0;
		}
		$intrating = floor($star_rating);
		$out.= "<span class='spPostRatingScore'>$star_rating</span>";
		$out.= '<span class="spPostRateStars">';
	    for ($x = 1; $x <= $intrating; $x++) {
			$name = ' id="star-'.$postid.'-'.$x.'"';
			if (is_numeric($voted) || !sp_get_auth('rate_posts', $spThisTopic->forum_id) || $spThisPost->user_id == $spThisUser->ID) {
				$link = '';
				$text = __('Current post rating', 'sp-rating').': '.$star_rating;
			} else {
				if ($x == 1) $text = __('Rate this post 1 star', 'sp-rating');
				if ($x == 2) $text = __('Rate this post 2 stars', 'sp-rating');
				if ($x == 3) $text = __('Rate this post 3 stars', 'sp-rating');
				if ($x == 4) $text = __('Rate this post 4 stars', 'sp-rating');
				if ($x == 5) $text = __('Rate this post 5 stars', 'sp-rating');
                $site = SFHOMEURL.'index.php?sp_ahah=rating-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;fid='.$spThisTopic->forum_id."&amp;pid=$postid&amp;rate=$x";
				$link = 'style="cursor: pointer;" onclick="javascript:spRatingRatePost(\''.$postid.'\', \''.$site.'\', 2);" onmouseover="spRatingStarHover(\''.$postid.'\', \''.$x.'\', \''.$overimg.'\')" onmouseout="spRatingStarUnhover(\''.$postid.'\', \''.$intrating.'\', \''.$onimg.'\', \''.$offimg.'\')" ';
			}
			$out.= '<img'.$name.' class="spIcon vtip" src="'.$onimg.'" alt="" title="'.esc_attr($text).'" '.$link.'/>';
		}

	    for ($x = ($intrating+1); $x <= 5; $x++) {
			$name = ' id="star-'.$postid.'-'.$x.'"';
			if (is_numeric($voted)  || !sp_get_auth('rate_posts', $spThisTopic->forum_id) || $spThisPost->user_id == $spThisUser->ID) {
				$link = '';
				$text = __("Current post rating: ", 'sp-rating').$star_rating;
			} else {
				if ($x == 1) $text = __('Rate this post 1 star', 'sp-rating');
				if ($x == 2) $text = __('Rate this post 2 stars', 'sp-rating');
				if ($x == 3) $text = __('Rate this post 3 stars', 'sp-rating');
				if ($x == 4) $text = __('Rate this post 4 stars', 'sp-rating');
				if ($x == 5) $text = __('Rate this post 5 stars', 'sp-rating');
                $site = SFHOMEURL.'index.php?sp_ahah=rating-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;fid='.$spThisTopic->forum_id."&amp;pid=$postid&amp;rate=$x";
				$link = 'style="cursor: pointer;" onclick="javascript:spRatingRatePost(\''.$postid.'\', \''.$site.'\', 2);" onmouseover="spRatingStarHover(\''.$postid.'\', \''.$x.'\', \''.$overimg.'\')" onmouseout="spRatingStarUnhover(\''.$postid.'\', \''.$intrating.'\', \''.$onimg.'\', \''.$offimg.'\')" ';
			}
			$out.= '<img'.$name.' class="spIcon vtip" src="'.$offimg.'" alt="" title="'.esc_attr($text).'" '.$link.'/>';
		}
		$out.= '</span>';
	}
	$out.= '</div>';
	$out.= '</div>';

	$out = apply_filters('sph_PostIndexRatePost', $out, $a);
	echo $out;
}
?>