<?php
/*
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_TopicIndexRatingTag($args='', $summaryLabel='') {
	global $spVars, $spThisTopic, $spThisUser, $spThisForum;

	# bail if post rating not enabled for current forum
	if ($spThisForum) {
	   if (!$spThisForum->post_ratings) return;
    } else if ($spThisTopic && !$spThisTopic->post_ratings) {
        return;
    }

    include_once(PRLIBDIR.'sp-rating-database.php');

	$defs = array('tagId' 		=> 'spTopicIndexRating%ID%',
				  'tagClass' 	=> 'spTopicRating',
				  'statusClass'	=> 'spIconNoAction',
				  'thumbClass'	=> 'spTopicRatingThumbs',
				  'starClass'	=> 'spTopicRatingStars',
                  'skipZero'    => '0',
                  'stacked'     => '0',
				  );
	$a = wp_parse_args($args, $defs);
	$a = apply_filters('sph_spTopicIndexRating_args', $a);
	extract($a, EXTR_SKIP);

	# sanitize before use
	$tagId			= esc_attr($tagId);
	$tagClass		= esc_attr($tagClass);
	$statusClass	= esc_attr($statusClass);
	$thumbClass	    = esc_attr($thumbClass);
	$starClass	    = esc_attr($starClass);
	$skipZero       = (int) $skipZero;
	$stacked        = (int) $stacked;
	if (!empty($summaryLabel)) 	$summaryLabel = sp_filter_title_display($summaryLabel);

	$tagId = str_ireplace('%ID%', $spThisTopic->topic_id, $tagId);

	$out = '';

	$postratings = sp_get_option('postratings');
	$sum = 0;
	$count = 0;
	$ratings = sp_get_topic_ratings($spThisTopic->topic_id);
	if ($ratings) {
		# get overall topic rating
		foreach ($ratings as $rating) {
			$sum += $rating->ratings_sum;
			$count += $rating->vote_count;
		}
	}

    if ($skipZero && $count == 0) return;

	# display the topic rating
	if ($postratings['ratingsstyle'] == 1) { # thumb rating
        # calculate aggregate rating
		$downimg = sp_find_icon(PRIMAGES, 'sp_RateDown.png');
		$upimg = sp_find_icon(PRIMAGES, 'sp_RateUp.png');
        $sumtext = ($sum > 0) ? '+'.$sum : $sum;
        $text = "$summaryLabel $sumtext";
   		$out.= "<div id='$tagId' class='$tagClass $thumbClass'>";
        if ($spVars['pageview'] == 'topic') {
            # display the icons
    		$out.= '<span class="spPostRateThumbs">';
    		if ($sum < 0) {
    			$out.= "<img class='spIcon vtip' src='$downimg' alt='' title='$text' />";
    		} else {
    			$out.= "<img class='spIcon vtip' src='$upimg' alt='' title='$text' />";
    		}
    		$out.= '</span>';

            # aggregate summary
            if ($stacked) $out.= '<br />';
            $out.= '<span class="hreview-aggregate">';
            $out.= "<span class='rating'> $summaryLabel ";
            $out.= "<span class='average'> $sumtext </span>";
            $out.= '<span class="best">';
            $out.= "<span class='value-title' title='$count'></span>";
            $out.= '</span>';
            $out.= '<span class="worst">';
            $out.= "<span class='value-title' title='-$count'></span>";
            $out.= '</span>';
            $out.= "<span class='count'> ($count </span>".__('votes', 'sp-rating');
            $out.= ')&nbsp;</span>';
            $out.= '</span>';
        } else {
    		if ($sum < 0) {
    			$out.= "<img class='spIcon vtip $statusClass' src='$downimg' alt='' title='$text' />";
    		} else {
    			$out.= "<img class='spIcon vtip $statusClass' src='$upimg' alt='' title='$text' />";
    		}
    		$out.= "<span class='average'>$sumtext</span>";
        }
   		$out.= '</div>';
	} else {  # stars
        # calculate aggregate rating
		if ($count) {
			$star_rating = round($sum / $count, 1);
			$img = sp_find_icon(PRIMAGES, 'sp_RateStarOn.png');
		} else {
			$star_rating = 0;
			$img = sp_find_icon(PRIMAGES, 'sp_RateStarOff.png');
		}
		$text = "$summaryLabel $star_rating";
		$out.= "<div id='$tagId' class='$tagClass $starClass'>";
        if ($spVars['pageview'] == 'topic') {
    		$offimg = sp_find_icon(PRIMAGES, 'sp_RateStarOff.png');
	       	$onimg = sp_find_icon(PRIMAGES, 'sp_RateStarOn.png');
    		$intrating = floor($star_rating);
    		$out.= '<span class="spPostRateStars">';

            # display the icons
    	    for ($x = 1; $x <= $intrating; $x++) {
    			$out.= "<img class='spIcon vtip' src='$onimg' alt='$text' title='$text' />";
    		}
    	    for ($x = ($intrating+1); $x <= 5; $x++) {
    			$out.= "<img class='spIcon vtip' src='$offimg' alt='$text' title='$text' />";
    		}
    		$out.= '</span>';

            # aggregate summary
            if ($stacked) $out.= '<br />';
            $out.= '<span class="hreview-aggregate">';
            $out.= "<span class='rating'> $summaryLabel ";
            $out.= "<span class='average'> $star_rating </span>";
            $out.= '</span>';
            $out.= "<span class='count'> ($count </span>".__('votes', 'sp-rating');
            $out.= ')&nbsp;</span>';
        } else {
    		$out.= "<img class='spIcon vtip $statusClass' src='$img' alt='' title='$text' />";
    		$out.= "<span class='average'>$star_rating</span>";
        }
		$out.= '</div>';
	}

	$out = apply_filters('sph_spTopicIndexRating', $out, $a);
	echo $out;
}
?>